//******************************************************************************
// *
// *       XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
// *       AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND
// *       SOLUTIONS FOR XILINX DEVICES. BY PROVIDING THIS DESIGN, CODE,
// *       OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
// *       APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION
// *       THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
// *       AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
// *       FOR YOUR IMPLEMENTATION. XILINX EXPRESSLY DISCLAIMS ANY
// *       WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
// *       IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
// *       REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
// *       INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// *       FOR A PARTICULAR PURPOSE.
// *
// *		Copyright(C) 2005 by xilinx, Inc. All rights reserved.              
// *
// *       (c) Copyright 2007 Xilinx Inc.
// *       All rights reserved.
//*
// ******************************************************************************/

#include "usbapp.h"

//#define BSZ 1024 * 64
#define BSZ 32768
#define NT  3

DWORD WINAPI ReadThread(LPVOID lpParam);
DWORD WINAPI WriteThread(LPVOID lpParam);

int __cdecl main(int argc, char *argv[])
{
    int results = 0;
    int i;
    int j;
    DWORD bytesWritten;
    HANDLE hThread[6];
    HANDLE ep1Write;
    HANDLE ep4Read;


    if((results = USBInit()) != ERROR_SUCCESS)
    {
        printf("USBApp: USBInit failed, err = %x\n", results);
      //  goto FuncExit;
    }

    // We will Loop EP 1 to 4
    if((results = USBOpen(1)) != ERROR_SUCCESS)
    {
        printf("USBApp: USBOpen of ep 1, err = %x\n", results);
     //   goto FuncExit;
    }

    if((results = USBOpen(4)) != ERROR_SUCCESS)
    {
        printf("USBApp: USBOpen of ep 4, err = %x\n", results);
      //  goto FuncExit;
    }

    if((results = USBOpen(2)) != ERROR_SUCCESS)
    {
        printf("USBApp: USBOpen of ep 4, err = %x\n", results);
      //  goto FuncExit;
    }

    if((results = USBOpen(5)) != ERROR_SUCCESS)
    {
        printf("USBApp: USBOpen of ep 4, err = %x\n", results);
      //  goto FuncExit;
    }

    if((results = USBOpen(3)) != ERROR_SUCCESS)
    {
        printf("USBApp: USBOpen of ep 4, err = %x\n", results);
      //  goto FuncExit;
    }

    if((results = USBOpen(6)) != ERROR_SUCCESS)
    {
        printf("USBApp: USBOpen of ep 4, err = %x\n", results);
       // goto FuncExit;
    }

    j = 0; // thread table index

    for (i = 1; i < (NT + 1); i++) 
    {
        hThread[j] = CreateThread(
                                NULL,
                                0,
                                WriteThread,
                                (LPVOID) i,
                                0,
                                NULL
                              );

        if(hThread[j] == NULL)
        {
            printf("WriteThread  ep = %d did not start: exiting\n", i);
            goto FuncExit;
        }

        j++;

    }


    for (i = 4; i < (NT + 4); i++) 
    {
        hThread[j] = CreateThread(
                                NULL,
                                0,
                                ReadThread,
                                (LPVOID) i,
                                0,
                                NULL
                              );

        if(hThread[j] == NULL)
        {
            printf("ReadThread  ep = %d did not start: exiting\n", i);
            goto FuncExit;
        }

        j++;

    }

    // Wait for the threads to do their work
    WaitForMultipleObjects(j, hThread, TRUE, INFINITE);

    // All done, exit
    results = 0;

FuncExit:
    return(results);
}

DWORD WINAPI ReadThread(LPVOID lpParam)
{   
    int ep;
    int i;
    DWORD bytesRead;
    char inBuffer[BSZ];

    //return(0);
    ep = (int) lpParam;
    bytesRead = 0;
    printf("ReadThread %d start\n", ep);

    // Lets run for 100 loops
    i = 100;
    while (i--) 
    {
        bytesRead += USBRead(ep, &inBuffer[0], BSZ);

    }
    printf("ReadThread %d end\n", ep);
    return(0);
}

DWORD WINAPI WriteThread(LPVOID lpParam)
{
    int ep;
    int i;
    DWORD bytesWritten;
    char outBuffer[BSZ];

    ep = (int) lpParam;
    bytesWritten = 0;
    printf("WriteThread %d start\n", ep);

    // Lets run for 100 loops
    i = 100;
    while (i--) 
    {
        bytesWritten += USBWrite(ep, outBuffer, BSZ);
    }
    printf("WriteThread %d end\n", ep);
    return(0);
}

